package com.sa.ibiz.demo.demoapp.controller.demo.vo;

import java.sql.Timestamp;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.Data;
import com.sa.ibiz.demo.demo.domain.UserRoleRes;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import java.math.BigInteger;
import java.util.HashMap;
import java.util.Map;
import java.util.List;
import java.util.ArrayList;
import org.springframework.cglib.beans.BeanMap;
import com.alibaba.fastjson.JSONObject;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class UserRoleRes_Grid_Main{
    private String userroleresid;
    private String uniresname;
    private String uniresid;
    private String updateman;
    private String userrolename;
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", timezone="GMT+8")
    private Timestamp updatedate;
    private String srfmajortext;


    private String srfdataaccaction;


    private String srfkey;


    private String userroleid;
    public  void fromUserRoleRes(UserRoleRes sourceEntity)  {
         this.setUserroleresid(sourceEntity.getUserroleresid());
         this.setUniresname(sourceEntity.getUniresname());
         this.setUniresid(sourceEntity.getUniresid());
         this.setUpdateman(sourceEntity.getUpdateman());
         this.setUserrolename(sourceEntity.getUserrolename());
         this.setUpdatedate(sourceEntity.getUpdatedate());
         this.setSrfmajortext(sourceEntity.getUserroleresname());
         this.setSrfdataaccaction(sourceEntity.getUserroleresid());
         this.setSrfkey(sourceEntity.getUserroleresid());
         this.setUserroleid(sourceEntity.getUserroleid());
	}

	public static Page<UserRoleRes_Grid_Main> fromUserRoleRes(Page<UserRoleRes> sourcePage)  {
        if(sourcePage==null)
            return null;
        Page<UserRoleRes_Grid_Main> targetpage=new Page<UserRoleRes_Grid_Main>(sourcePage.getCurrent(),sourcePage.getSize(),sourcePage.getTotal(),sourcePage.isSearchCount());
        List<UserRoleRes_Grid_Main> records=new ArrayList<UserRoleRes_Grid_Main>();
        for(UserRoleRes source:sourcePage.getRecords()) {
            UserRoleRes_Grid_Main target=new UserRoleRes_Grid_Main();
            target.fromUserRoleRes(source);
            records.add(target);
        }
        targetpage.setAsc(sourcePage.ascs());
        targetpage.setDesc(sourcePage.descs());
        targetpage.setOptimizeCountSql(sourcePage.optimizeCountSql());
        targetpage.setRecords(records);
        return targetpage;
    }

    /**
     * 表格模型集合
     * @return
     */
    public static List<Map<String,String>> getGridColumnModels() {
        List columnModelList =new ArrayList();
        columnModelList.add(new HashMap(){ { put("userrolename","用户角色"); }});
        columnModelList.add(new HashMap(){ { put("updateman","更新人"); }});
        columnModelList.add(new HashMap(){ { put("updatedate","更新时间"); }});
        columnModelList.add(new HashMap(){ { put("uniresname","资源"); }});
        return columnModelList;
    }

    /**
     *将entity转成map
     * @param bean
     * @param <T>
     * @return
     */
    public <T> Map<String,Object> beanToMap(T bean){
        Map map =new HashMap<String,Object>();
        if(bean!=null){
            BeanMap beanMap=BeanMap.create(bean);
            for(Object obj:beanMap.keySet()){
                map.put(obj+"",beanMap.get(obj));
            }
        }
        return map;
    }

    /**
     * 将entity转成map
     * @param searchResult
     * @return
     */
    public static List<Map<String, Object>> pageToListDatas(Page<UserRoleRes> searchResult) {
        if(searchResult==null)
            return null;
        List<Map<String, Object>> records=new ArrayList<>();
        for(UserRoleRes source:searchResult.getRecords()) {
            UserRoleRes_Grid_Main target=new UserRoleRes_Grid_Main();
            records.add(target.beanToMap(source));
        }
        return records;
    }

    /**
     * 输出表格数据导出文件url
     * @param sourcePage
     * @param downloadurl
     * @return
     */
    public static Page<JSONObject> getResultPage(Page<UserRoleRes> sourcePage,String downloadurl)  {
        if(sourcePage==null)
            return null;
        Page<JSONObject> targetpage=new Page<JSONObject>(sourcePage.getCurrent(),sourcePage.getSize(),sourcePage.getTotal(),sourcePage.isSearchCount());
        List<JSONObject> records=new ArrayList<JSONObject>();
        JSONObject obj =new JSONObject();
        obj.put("downloadurl",downloadurl);
        records.add(obj);
        targetpage.setAsc(sourcePage.ascs());
        targetpage.setDesc(sourcePage.descs());
        targetpage.setOptimizeCountSql(sourcePage.optimizeCountSql());
        targetpage.setRecords(records);
        return targetpage;
    }


}